// This code is derived from jcifs smb client library <jcifs at samba dot org>
// Ported by J. Arturo <webmaster at komodosoft dot net>
//  
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
using SharpCifs.Smb;
using System.Threading.Tasks;

namespace SharpCifs.Dcerpc.Msrpc
{
	public class SamrDomainHandle : Rpc.PolicyHandle
	{
        DcerpcHandle _handle;
        SamrPolicyHandle _policyHandle;
        int _access;
		Rpc.SidT _sid;

		/// <exception cref="System.IO.IOException"></exception>
        public SamrDomainHandle()
		{
		}

        public virtual async Task OpenAsync(DcerpcHandle handle, SamrPolicyHandle policyHandle, int access, Rpc.SidT sid)
        {
            _handle = handle;
            _policyHandle = policyHandle;
            _access = access;
            _sid = sid;
            MsrpcSamrOpenDomain rpc = new MsrpcSamrOpenDomain(_policyHandle, _access, _sid, this
				);
			await _handle.Sendrecv(rpc);
			if (rpc.Retval != 0)
			{
				throw new SmbException(rpc.Retval, false);
			}
        }

		/// <exception cref="System.IO.IOException"></exception>
		public virtual void Close()
		{
		}
	}
}
