using System.Threading.Tasks;
namespace SharpCifs.Util.Sharpen
{
    public class FilterInputStream : InputStream
	{
		protected InputStream In;

		public FilterInputStream (InputStream s)
		{
			In = s;
		}

		public override async Task<int> AvailableAsync ()
		{
			return await In.AvailableAsync ();
		}

		public override async Task Close ()
		{
			await In.Close ();
		}

		public override void Mark (int readlimit)
		{
			In.Mark (readlimit);
		}

		public override bool MarkSupported ()
		{
			return In.MarkSupported ();
		}

        public override async Task<int> ReadAsync()
		{
            return await In.ReadAsync();
		}

        public override async Task<int> ReadAsync(byte[] buf)
		{
            return await In.ReadAsync(buf);
		}

        public override async Task<int> ReadAsync(byte[] b, int off, int len)
		{
            return await In.ReadAsync(b, off, len);
		}

		public override void Reset ()
		{
			In.Reset ();
		}

		public override async Task<long> SkipAsync (long cnt)
		{
			return await In.SkipAsync (cnt);
		}
	}
}
