using System.Threading.Tasks;
namespace SharpCifs.Util.Sharpen
{
    internal class PipedOutputStream : OutputStream
	{
		PipedInputStream _ips;

		public PipedOutputStream ()
		{
		}

		public PipedOutputStream (PipedInputStream iss) : this()
		{
			Attach (iss);
		}

        public override async Task Close()
		{
			await _ips.Close ();
			await base.Close ();
		}

		internal void Attach (PipedInputStream iss)
		{
			_ips = iss;
		}

        public override async Task WriteAsync(int b)
		{
			await _ips.WriteAsync (b);
		}

        public override async Task WriteAsync(byte[] b, int offset, int len)
		{
			await _ips.WriteAsync (b, offset, len);
		}
	}
}
